<template>
    <ion-modal :is-open="isOpenLocal" @willDismiss="onWillDismiss">
        <ion-header>
            <ion-toolbar>
                <ion-buttons slot="end">
                    <ion-button @click="closeModal()">Zpět</ion-button>
                </ion-buttons>
                <ion-title>Skupiny</ion-title>
            </ion-toolbar>
        </ion-header>

        <ion-content class="ion-padding">
            <ion-progress-bar
                v-if="loading"
                type="indeterminate"
            ></ion-progress-bar>
            <ion-item>
                <ion-grid>
                    <ion-row v-for="group in groupList" :key="group.id">
                        <group-card
                            @editClick="editGroup"
                            @removeClick="remove"
                            :group="group"
                        />
                    </ion-row>
                </ion-grid>
            </ion-item>
        </ion-content>
    </ion-modal>
</template>

<script lang="ts" setup>
import {
    IonGrid,
    IonRow,
    IonProgressBar,
    IonButton,
    IonButtons,
    IonModal,
    IonHeader,
    IonContent,
    IonToolbar,
    IonTitle,
    IonItem,
} from '@ionic/vue'
import { useLazyQuery, useMutation } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { computed, ref, watch } from 'vue'
import GroupCard from './GroupCard.vue'
import router from '@/router'
import { Route } from '@/router/route'
import toast from '@/helpers/toast'

const props = defineProps<{
    isOpen?: boolean
    userId?: string
}>()

const emit = defineEmits(['closeModal'])

const { loading, result, load, refetch } = useLazyQuery(
    gql`
        query deviceGroupModal($id: ID!) {
            appUser(id: $id) {
                deviceGroupList {
                    id
                    name
                    isActive
                    createdAt
                    updatedAt
                    deviceList {
                        id
                        ip
                        name
                        mac
                    }
                }
            }
        }
    `,
    () => ({ id: props.userId })
)

const groupList = computed(() => result?.value?.appUser?.deviceGroupList ?? [])

const isOpenLocal = ref(false)

const onWillDismiss = () => emit('closeModal')
const closeModal = () => (isOpenLocal.value = false)

watch(
    () => props.isOpen,
    (isOpen) => {
        isOpenLocal.value = isOpen
    }
)

watch(
    () => props.userId,
    () => load()
)

const editGroup = (id: string) => {
    isOpenLocal.value = false
    router.push({ name: Route.group, params: { id } })
}

// Smazat

const { mutate: removeDeviceGroup } = useMutation(gql`
    mutation removeDeviceGroup2($id: ID!) {
        removeDeviceGroup(id: $id)
    }
`)

const remove = (id: string) =>
    removeDeviceGroup({ id }).then(() => {
        refetch()
        toast(id + ' smazáno', 'success')
    })
</script>
